// Kasiopea 2013 http://ksp.mff.cuni.cz/akce/kasiopea
// Autorské řešení 3. úlohy "Barevné proužky"
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

#define FOR(i, m, n) for (int i=m; i<n; i++)

struct Elem {
	Elem(int A, int I, int C) : a(A), i(I), c(C) {}
	int a;
	int i;
	int c;
	bool operator<(const Elem &p) const {
		return (a<p.a || (a==p.a && i<p.i));
	}
};

int N;
vector<Elem> e;
set<int> mn;
map<int,int> cnt;

int main()
{
  freopen("vstup.in", "r", stdin);
  freopen("vystup.out", "w", stdout);
  
  scanf("%d", &N);
  FOR (i, 1, N+1) {
	  int a, b, c; scanf("%d%d%d", &a, &b, &c);
	  e.push_back(Elem(a,-i,c));
	  e.push_back(Elem(b,i,c));
	  cnt[c] = 0;
  }
  int ans = 0, index = -1;
  sort(e.begin(), e.end());
  FOR (i, 0, e.size()) {
	  if (e[i].i<0) {
		  mn.insert(e[i].c);
		  cnt[e[i].c]++;
	  }
	  else {
		  cnt[e[i].c]--;
		  if (cnt[e[i].c]==0)
			  mn.erase(mn.find(e[i].c));
	  }
	  if (mn.size()>ans) {
		  ans = mn.size();
		  index = e[i].a;
	  }
  }
  
  printf("%d %d\n", ans, index);
  
  fclose(stdin);
  fclose(stdout);
  return 0;
}
